// About.java
/* A Java class for
 * LineImpedance.java
 * Electromagnetic Transmission Line Applet
 * Applet without Smith Chart - Prepared by Umberto Ravaioli 
 * for 6th edition of Fundamentals of Applied Electromagnetics Book
 * May 2009 - All Rights Reserved
 */   


import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.*;
import java.net.URL;
import java.text.*;
import java.util.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.jar.Attributes;


public class Instructions extends Panel {
    
    private static final Color bgcolor = new Color(255,255,245);
    //private static final Color bgcolor = Color.white;
    
    public TextField epsilon;
    private Paint paint;
    
    private Image im;
    private Graphics buf;

    //Mod1State state;
    public Button bupdate;
  
    public Instructions(){
	super();
        //this.state = state;
	setLayout(null);
	setBackground(bgcolor);
	bupdate = new Button("CLOSE");
        bupdate.setBackground(new Color(240,240,255));
	add(bupdate);
        //int buttonx = 380;
        //int buttony = 380;
        int buttonx = 435;
        //int buttony = 440;
        int buttony = 525;
        int buttonwide = 70;
        int buttonheight = 27;
        
        bupdate.setBounds(buttonx,buttony,buttonwide,buttonheight);	
        Panel ps7 = new Panel();
	    ps7.setBackground(Color.lightGray);
	    add(ps7);
	    ps7.setBounds(buttonx-1,buttony-1,buttonwide+2,buttonheight+2);
	    
	Panel ps8 = new Panel();
	    ps8.setBackground(Color.black);
	    add(ps8);
	    ps8.setBounds(buttonx-2,buttony-2,buttonwide+4,buttonheight+4);	
    }
    
    public void paint(Graphics g){
            
	    if(im == null){
		im = createImage(getSize().width,getSize().height);
		buf = im.getGraphics();
		drawCanvas(buf);
	    }
	    else{
		drawCanvas(buf);
	    }
	    g.drawImage(im,0,0,null);
    }
	
	//Addition to reduce flicker new routine
    public void update(Graphics g){		// added to avoid clearing
            paint(g);
    }
    
    public void clear(){
	    this.getGraphics().clearRect(0,0,getSize().width,getSize().height);
	    repaint();
    }
    
    public void drawCanvas(Graphics g){
        FontMetrics fm;
        Graphics2D g2d = (Graphics2D)g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON);        
        g.clearRect(0,0,getSize().width-1,getSize().height-1);

        //g.setFont(font_one);
        //fm = g.getFontMetrics();

        //boolean saveOldFlag = MaestroG.useBiggerFont;
        //MaestroG.useBiggerFont = false;
        
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,16f));
        g.setFont(new Font("SanSerif",Font.BOLD,16));
        
        g.drawString("Instructions", 15,25);
        
        //g.setFont(state.ttfFont.deriveFont(14f));
        //g.setFont(new Font("SanSerif",Font.PLAIN,14));
        //g.drawString("This module can accomodate linearly polarized plane "+
        //            "waves in both lossy and lossless media.",15,50);
        
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));

        g.drawString("Input", 15,60);  // was 50
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        int deltaY = 20;
        //INPUT
        String s = "\u2022 \u03b5"+STR.SUB+"r1"+STR.ENDSUB+" and \u03bc"+
            STR.SUB+"r1"+STR.ENDSUB+" of medium 1 (lossless)";
        int nextX = STR.displayString(s,g,15,80);
        s = "\u2022 \u03b5"+STR.SUB+"r2"+STR.ENDSUB+" and \u03bc"+
            STR.SUB+"r2"+STR.ENDSUB+" of medium 2 (lossless or lossy)";
        nextX = STR.displayString(s,g,15,80+deltaY);
        s = "\u2022 Wave frequency "+STR.ITAL+"f"+STR.ENDITAL;
        nextX = STR.displayString(s,g,15,80+2*deltaY);
        s = "\u2022 Polarization of incident wave (parallel or perpendicular)";
        nextX = STR.displayString(s,g,15,80+3*deltaY);
        s = "\u2022 Incidence angle";
        nextX = STR.displayString(s,g,15,80+4*deltaY);
       //OUTPUT
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));
        int newY = 100+5*deltaY;  // was 6*  +40
        g.drawString("Displayed Information", 15,newY);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        newY += 20;
        s = "\u2022 Vector diagram of electric and magnetic fields";
        nextX = STR.displayString(s,g,15,newY);
        s = "\u2022 Components of "+STR.BOLD+"E"+STR.ENDBOLD+" and "+
            STR.BOLD+"H"+STR.ENDBOLD+" of incident, reflected and "+
            "transmitted waves";
        nextX = STR.displayString(s,g,15,newY+deltaY);
        s = "\u2022 Plots of "+STR.ITAL+"\u0393"+STR.ENDITAL+" and"+STR.ITAL+" \u03c4"+STR.ENDITAL+" versus incidence angle";
        nextX = STR.displayString(s,g,15,newY+2*deltaY);
        drawCopyRight(g);

        //MaestroG.useBiggerFont = saveOldFlag;

    }


    public void drawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 70;
        int startingX = 0;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        fm = g.getFontMetrics();
        g.drawString("Applet Design: Umberto Ravaioli",
                     startingX+10,startingY+deltaY);
        
        //MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
        //                       g,14,startingX,startingY+2*deltaY);
        String s = "Interactive Java"+STR.SUP+"TM"+STR.ENDSUP+
            " platform:  www.amanogawa.com";
        int nextX = STR.displayString(s,g,startingX+10,startingY+2*deltaY);
        int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        lineLength+= 10;

        //g.setFont(state.ttfFont.deriveFont(14f));
        g.drawString("All Rights Reserved",startingX+10,startingY+3*deltaY);
        g.drawLine(startingX,startingY+5,
                   startingX+lineLength+10,startingY+5);
        g.drawLine(startingX+lineLength+10,startingY+5,
                   startingX+lineLength+10,startingY+4*deltaY);
    }

//----------------------------------------------------------------------------------------    
}//End
    

